// knk_args.h

#ifndef INCLUDED_KNK_ARGS
#define INCLUDED_KNK_ARGS

#ifndef INCLUDED_NJS_SYSTEM
#include <njs_system.h>
#endif


using namespace std;

namespace Knk {
// Variables to store command line options, and also includes a function to parse them.
	namespace args {

			extern string command;   //--will hold the command line
			extern char* genomicfile;   //--input file containing fasta-formated genomic sequences
			extern char* seqlenfile;   // lengths for genomic sequences
			extern char* chipseqfile;
			extern char* mappabilitydir;
			extern char* regionOutFile; // region output file
			extern char* anchoredCntFile;
			extern char* motifLocFile;
			extern char* simdatafile; 
			extern long winSize;
			extern long minTagNum;
			extern double beta;
			extern double sigma;
			extern long tagLen;
			extern long motifLen;
			extern long tabVecLen;
			extern bool find2ndPeaks;
			extern long distMotSite;
			extern bool useBIC;

			void parse(		// parse the arguments using getopt
			int argc,		//number of arguments
			char **argv);   //arguments

	}
}

#endif

