// njs_normmix.h

#ifndef INCLUDED_KNK_NORMMIX
#define INCLUDED_KNK_NORMMIX

#ifndef INCLUDED_NJS_SYSTEM
#include <njs_system.h>
#endif

#ifndef INCLUDED_NJS_FUNCTION
#include <njs_function.h>
#endif

/*****************************************************************************
 
************************** NORMAL Mixture DISTRIBUTION ROUTINES **************
  
*****************************************************************************/

namespace Knk {

  namespace Normmix {

    double cdfN(double zscore_); //returns CDF of Normal(0,1) 

    int normexp(
		double beta_,
		double sigma_,
		size_t len_,
		double * densityLeft_,
		double * densityRight_,
		double * derivativeLeft_ = 0,  //wrt mu
		double * derivativeRight_ = 0);//wrt mu

    int normexp(
		double beta_,
		double sigma_,
		size_t len_,
		int direction_, //1 for the support of Expnential being on the left, 2 on the right
		double * values_);
    // range:  [- k , k - 1] if lenth is 2k. e.g., range is [-500, 499] of integers when lenth is 1000
    // location of 0 is for x = mu, which can be found at the middle (k+1)st element of the vector

    /*
    double standardVariate (); // returns RV normal (0, 1)

    inline double variate (    // returns RV normal (0, 1)
			   double mu = 0.0,                    // mean
			   double sigma = 1.0)                 // standard deviation
      {return mu + sigma * standardVariate ();}

    double rightTail (
		      double x,                           // argument
		      int *error,                         // error = 0 : error-free return
		      double rtol = Function::RTOL,       // tolerance 
		      double mu = 0.0,                    // mean
		      double sigma = 1.0);                // standard deviation

    double density (double x);  // Normal density 
      
    double sigLevel (           // Gaussian significance level 
		     double p,
		     int *error,
		     double tol = Function::TOL);
   
    */
  }

}

#endif //! INCLUDED_KNK_NORMMIX
