// njs_normal.h

#ifndef INCLUDED_NJS_NORMAL
#define INCLUDED_NJS_NORMAL

#ifndef INCLUDED_NJS_SYSTEM
#include <njs_system.h>
#endif

#ifndef INCLUDED_NJS_FUNCTION
#include <njs_function.h>
#endif

/*****************************************************************************
 
************************** NORMAL DISTRIBUTION ROUTINES ****************************
  
*****************************************************************************/

namespace Njs {

   namespace Normal {

      double standardVariate (); // returns RV normal (0, 1)

      inline double variate (    // returns RV normal (0, 1)
      double mu = 0.0,                    // mean
      double sigma = 1.0)                 // standard deviation
      {return mu + sigma * standardVariate ();}

      double rightTail (
      double x,                           // argument
      int *error,                         // error = 0 : error-free return
      double rtol = Function::RTOL,       // tolerance 
      double mu = 0.0,                    // mean
      double sigma = 1.0);                // standard deviation

      double density (double x);  // Normal density 
      
      double sigLevel (           // Gaussian significance level 
      double p,
      int *error,
      double tol = Function::TOL);
   
   }

}

#endif //! INCLUDED_NJS_NORMAL

