// njs_rootfinder.h

#ifndef INCLUDED_NJS_ROOTFINDER
#define INCLUDED_NJS_ROOTFINDER

#ifndef INCLUDED_NJS_SYSTEM
#include <njs_system.h>
#endif

namespace Njs {

   namespace RootFinder {

      double newtonRaphson (                       // finds root f(x) = y with derivative y'
      double y,                                    // ordinate
      double (*f) (double x),                      // function
      double (*df) (double x),                     // derivative of function
      double p,                                    // interval end-point
      double x,                                    // initial guess 
      double q,                                    // interval end-point 
      double tol,                                  // absolute tolerance
      double rtol = 0.0);                          // relative tolerance

      double bisection (                           // finds root f(x) = y
      double y,                                    // f(x)=y
      double (*f) (double x),                      // function : param contains parameters
      double p,                                    // end-point
      double q,                                    // end-point
      double tol,                                  // absolute tolerance
      double rtol = 0.0);                          // relative tolerance

      double newtonRaphson (                       // finds root f(x) = y with derivative y'
      double y,                                    // ordinate
      double (*f) (double x, void *param),         // function : param contains parameters
      double (*df) (double x, void *param),        // derivative of function
      void *param,                                 // parameters for function
      double p,                                    // interval end-point
      double x,                                    // initial guess 
      double q,                                    // interval end-point 
      double tol,                                  // absolute tolerance
      double rtol = 0.0);                          // relative tolerance

      double bisection (                           // finds root f(x) = y
      double y,                                    // f(x)=y
      double (*f) (double x, void *param),         // function : param contains parameters
      void *param,                                 // parameters for function
      double p,                                    // end-point
      double q,                                    // end-point
      double tol,                                  // absolute tolerance
      double rtol = 0.0);                          // relative tolerance

   }

}

#endif //! INCLUDED_NJS_ROOTFINDER