// njs_uniform.cpp

#undef NJS_DEBUG

#include <njs_uniform.h>

#include <njs_variate.h>

using namespace Njs;

double Uniform::variate (          // returns RV uniform [a, b] 
double a,                          // lower limit 
double b)                          // upper limit
{
return (a < b ? a : b) + fabs (a - b) * (double) Variate::randomNum () / (double) 0x7fffffff; 
}

long Uniform::variate (            // returns RV discrete uniform [a, b] 
long a,                            // lower limit 
long b)                            // upper limit
{
   double random = 0.0;
   while ((random = standardVariate ()) == 1.0) {
   }
return (a < b ? a : b) + static_cast <long> ((abs (a - b) + 1) * random);
}

