// njs_uniform.h

#ifndef INCLUDED_NJS_UNIFORM
#define INCLUDED_NJS_UNIFORM

#include <njs_system.h>

/*****************************************************************************
 
*************************** UNIFORM VARIATE ROUTINES *************************
  
*****************************************************************************/

namespace Njs {

   namespace Uniform {               // Uniform distribution 

      double variate (               // returns RV uniform [a, b] 
      double a = 0.0,                // lower limit 
      double b = 1.0);               // upper limit

      inline double standardVariate ()
      {return variate (0.0, 1.0);}

      long variate (                 // returns RV discrete uniform [a, b] 
      long a,                        // lower limit 
      long b);                       // upper limit

   }

}

#endif //! INCLUDED_NJS_UNIFORM

